package cn.ibizlab.assetmanagement.core.plan.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.plan.domain.EAMPlan;
import cn.ibizlab.assetmanagement.core.plan.filter.EAMPlanSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMPlan] 服务对象接口
 */
public interface IEAMPlanService extends IService<EAMPlan>{

    boolean create(EAMPlan et) ;
    void createBatch(List<EAMPlan> list) ;
    boolean update(EAMPlan et) ;
    void updateBatch(List<EAMPlan> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMPlan get(String key) ;
    EAMPlan getDraft(EAMPlan et) ;
    boolean checkKey(EAMPlan et) ;
    boolean save(EAMPlan et) ;
    void saveBatch(List<EAMPlan> list) ;
    Page<EAMPlan> searchDefault(EAMPlanSearchContext context) ;
    List<EAMPlan> selectByAssetid(String assetid) ;
    void removeByAssetid(String assetid) ;
    List<EAMPlan> selectByEamlocationid(String eamlocationid) ;
    void removeByEamlocationid(String eamlocationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMPlan> getEamplanByIds(List<String> ids) ;
    List<EAMPlan> getEamplanByEntities(List<EAMPlan> entities) ;
}


